#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// ------------------------------------------------------------ Grupa A
char *aa( char *R )
{
	char *nova;
	int i, duljina, dobar, novaDuljina, n, j;
	
	n = strlen( R );
	i = 0; duljina = 0; dobar = 1; novaDuljina = 0;
	while( i <= n )
	{
		if( R[ i ] == ' ' || R[ i ] == '\0' )
		{
			if( dobar )
				break;
				
			duljina = 0; dobar = 1;
		}
		else
		{
			if( !( R[ i ] == 'a' || R[ i ] == 'e' || R[ i ] == 'i' || R[ i ] == 'o' || R[ i ] == 'u' ) )
				dobar = 0;
			
			++duljina;
		}
		
		++i; 
	}	

	if( !dobar )
		duljina = 0;
		
	nova = (char *) malloc( (duljina+1) * sizeof( char ) );
	for( j = 0; j < duljina; ++j )
		nova[ j ] = R[ i-duljina+j ];
		
	nova[ duljina ] = '\0';

	return nova;
}

void ab( char *R )
{
	int n, i, j, koliko = 0;
	
	n = strlen( R );
	for( i = 0; i <= n; ++i )
	{
		if( R[ i ] == ' ' || R[ i ] == '\0' )
			++koliko;
	
		if( koliko == 2 )
			break;		
	}
	
	if( koliko == 2 )
	{
		// shiftaj sve udesno za 5
		for( j = n; j >= i; --j ) 
			R[ j+5 ] = R[ j ];
			
		R[ i ] = ' ';
		R[ i+1 ] = 'P';
		R[ i+2 ] = 'r';
		R[ i+3 ] = 'o';
		R[ i+4 ] = 'g';
	}
}

int mainA( void )
{
	char R[ 51 ], *S;
	
	scanf( "%[^\n]", R );
	
	S = aa( R );
	ab( R );
	
	printf( "%s\n", S );
	printf( "%s\n", R );
	
	free( S );
	
	return 0;
}

// ------------------------------------------------------------ Grupa B
void ba( char *R )
{
	int i, j, n, dobar, duljina;
	
	n = strlen( R );
	i = 0; dobar = 1; duljina = 0;
	while( i <= n )
	{
		if( R[ i ] == ' ' || R[ i ] == '\0' )
		{
			if( dobar )
				break;
				
			dobar = 1; duljina = 0;
		}
		else
		{
			if( !( R[ i ] == '$' || R[ i ] == '!' || R[ i ] == '@' ) )
				dobar = 0;
				
			++duljina;
		}
		
		++i;
	}
	
	if( !dobar )
		duljina = 0;
		
	for( j = 0; j < duljina; ++j )
		R[ j ] = R[ i-duljina+j ];
	
	R[ duljina ] = '\0';
}

char *bb( char *R )
{
	char *nova;
	int i, j, n, koliko = 0;
	
	n = strlen( R );
	
	for( i = 0; i <= n; ++i )
	{
		if( R[ i ] == ' ' || R[ i ] == '\0' )
			++koliko;
			
		if( koliko == 2 )
			break;
	}
	
	if( koliko == 2 )
	{
		nova = (char *) malloc( (n+6) * sizeof( char ) );
		strcpy( nova, R );
		
		for( j = n; j >= i; --j )
			nova[ j+5 ] = nova[ j ];
		
		nova[ i ] = ' ';
		nova[ i+1 ] = nova[ i+2 ] = '$';
		nova[ i+3 ] = '@';
		nova[ i+4 ] = '!';
	}
	else
	{
		nova = (char *) malloc( (n+1) * sizeof( char ) );
		strcpy( nova, R );
	}
	
	return nova;
}

int mainB( void )
{
	char R[ 51 ], RR[ 51 ], *S;
	
	scanf( "%[^\n]", R ); strcpy( RR, R );
	
	ba( RR );
	S = bb( R );
	
	printf( "%s\n", RR );
	printf( "%s\n", S );
	
	free( S );
	
	return 0;
}

// ------------------------------------------------------------ Grupa C
char *ca( char *R )
{
	char *nova;
	int i, duljina, dobar, novaDuljina, n, j;
	
	n = strlen( R );
	i = 0; duljina = 0; dobar = 0; novaDuljina = 0;
	while( i <= n )
	{
		if( R[ i ] == ' ' || R[ i ] == '\0' )
		{
			if( dobar )
				break;
				
			duljina = 0; dobar = 0;
		}
		else
		{
			if( '0' <= R[ i ] && R[ i ] <= '9' )
				dobar = 1;
			
			++duljina;
		}
		
		++i; 
	}	

	if( !dobar )
		duljina = 0;
		
	nova = (char *) malloc( (duljina+1) * sizeof( char ) );
	for( j = 0; j < duljina; ++j )
		nova[ j ] = R[ i-duljina+j ];
		
	nova[ duljina ] = '\0';

	return nova;
}

void cb( char *R )
{
	int n, i, j, koliko = 0;
	
	n = strlen( R );
	for( i = n-1; i >= 0; --i )
	{
		if( i == 0 || R[ i-1 ] == ' ' )
			++koliko;
	
		if( koliko == 2 )
			break;		
	}
	
	if( koliko == 2 )
	{
		// shiftaj sve udesno za 5
		for( j = n; j >= i; --j ) 
			R[ j+5 ] = R[ j ];
			
		R[ i ] = '1';
		R[ i+1 ] = '2';
		R[ i+2 ] = '3';
		R[ i+3 ] = '4';
		R[ i+4 ] = ' ';
	}
}

int mainC( void )
{
	char R[ 51 ], *S;
	
	scanf( "%[^\n]", R );
	
	S = ca( R );
	cb( R );
	
	printf( "%s\n", S );
	printf( "%s\n", R );
	
	free( S );
	
	return 0;
}

// ------------------------------------------------------------ Grupa D
void da( char *R )
{
	int i, j, n, dobar, duljina;
	
	n = strlen( R );
	i = 0; dobar = 0; duljina = 0;
	while( i <= n )
	{
		if( R[ i ] == ' ' || R[ i ] == '\0' )
		{
			if( dobar )
				break;
				
			dobar = 0; duljina = 0;
		}
		else
		{
			if( 'a' <= R[ i ] && R[ i ] <= 'f' )
				dobar = 1;
				
			++duljina;
		}
		
		++i;
	}
	
	if( !dobar )
		duljina = 0;
		
	for( j = 0; j < duljina; ++j )
		R[ j ] = R[ i-duljina+j ];
	
	R[ duljina ] = '\0';
}

char *db( char *R )
{
	char *nova;
	int i, j, n, koliko = 0;
	
	n = strlen( R );
	for( i = n-1; i >= 0; --i )
	{
		if( i == 0 || R[ i-1 ] == ' ' )
			++koliko;
	
		if( koliko == 2 )
			break;		
	}
	
	if( koliko == 2 )
	{
		nova = (char *) malloc( (n+6) * sizeof( char ) );
		strcpy( nova, R );
		
		for( j = n; j >= i; --j ) 
			nova[ j+5 ] = nova[ j ];
			
		nova[ i ] = 'a';
		nova[ i+1 ] = 'b';
		nova[ i+2 ] = 'c';
		nova[ i+3 ] = 'd';
		nova[ i+4 ] = ' ';
	}
	else
	{
		nova = (char *) malloc( (n+1) * sizeof( char ) );
		strcpy( nova, R );
	}
	
	return nova;
}

int mainD( void )
{
	char R[ 51 ], RR[ 51 ], *S;
	
	scanf( "%[^\n]", R ); strcpy( RR, R );
	
	da( RR );
	S = db( R );
	
	printf( "%s\n", RR );
	printf( "%s\n", S );
	
	free( S );
	
	return 0;
}

// ------------------------------------------------------------ main
int main( void )
{
	printf( "\n\nGrupa A:\n" ); mainA(); fflush( stdin );
	printf( "\n\nGrupa B:\n" ); mainB(); fflush( stdin );
	printf( "\n\nGrupa C:\n" ); mainC(); fflush( stdin );
	printf( "\n\nGrupa D:\n" ); mainD();

	return 0;
}
