#include <stdio.h>
#include <stdlib.h>

// ------------------------------------------------------------ Grupa A
int broji( int red, int stup, int n, int k, int *povijestRed, int *povijestStup, int brojKorakaDosad )
{
	int i, total = 0;

	povijestRed[ brojKorakaDosad ] = red; povijestStup[ brojKorakaDosad ] = stup;
	
	if( k == 0 )
	{
		if( red == 1 && stup == 1 )
		{
			for( i = 0; i <= brojKorakaDosad; ++i )
				printf( "(%d, %d) ", povijestRed[ i ], povijestStup[ i ] );
			printf( "\n" );
		
			return 1;
		}
		else
			return 0;
	}
	
	for( i = 1; i <= n; ++i )
	{
		if( i != red )  total += broji( i, stup, n, k-1, povijestRed, povijestStup, brojKorakaDosad+1 );
		if( i != stup ) total += broji( red, i, n, k-1, povijestRed, povijestStup, brojKorakaDosad+1 );
	}
	
	return total;
}

// ------------------------------------------------------------ Grupa B
int koliko( int red, int stup, int n, int k, int *povijestRed, int *povijestStup, int brojKorakaDosad )
{
	int i, total = 0;

	povijestRed[ brojKorakaDosad ] = red; povijestStup[ brojKorakaDosad ] = stup;
	
	if( k == 0 )
	{
		if( red == 1 && stup == 1 )
		{
			for( i = 0; i <= brojKorakaDosad; ++i )
				printf( "(%d, %d) ", povijestRed[ i ], povijestStup[ i ] );
			printf( "\n" );
		
			return 1;
		}
		else
			return 0;
	}
	
	for( i = -n; i <= n; ++i )
	{
		if( i != 0 && 1 <= red+i && red+i <= n && 1 <= stup+i && stup+i <= n )  
			total += koliko( red+i, stup+i, n, k-1, povijestRed, povijestStup, brojKorakaDosad+1 );
			
		if( i != 0 && 1 <= red-i && red-i <= n && 1 <= stup+i && stup+i <= n )  
			total += koliko( red-i, stup+i, n, k-1, povijestRed, povijestStup, brojKorakaDosad+1 );
	}
	
	return total;
}

// ------------------------------------------------------------ Grupa C
int nkn( int red, int stup, int n, int k, int *povijestRed, int *povijestStup, int brojKorakaDosad )
{
	int i, total = 0;

	povijestRed[ brojKorakaDosad ] = red; povijestStup[ brojKorakaDosad ] = stup;
	
	if( k < 0 )
		return 0;
	
	if( red == 1 && stup == 1 )
	{
		for( i = 0; i <= brojKorakaDosad; ++i )
			printf( "(%d, %d) ", povijestRed[ i ], povijestStup[ i ] );
		printf( "\n" );
		
		++total;
	}
	
	for( i = 1; i <= n; ++i )
	{
		if( i != red )  total += nkn( i, stup, n, k-1, povijestRed, povijestStup, brojKorakaDosad+1 );
		if( i != stup ) total += nkn( red, i, n, k-1, povijestRed, povijestStup, brojKorakaDosad+1 );
	}
	
	return total;
}

// ------------------------------------------------------------ Grupa D
int prebroji( int red, int stup, int n, int k, int *povijestRed, int *povijestStup, int brojKorakaDosad )
{
	int i, total = 0;

	povijestRed[ brojKorakaDosad ] = red; povijestStup[ brojKorakaDosad ] = stup;
	
	if( k < 0 )
		return 0;
	
	if( red == n && stup == n )
	{
		for( i = 0; i <= brojKorakaDosad; ++i )
			printf( "(%d, %d) ", povijestRed[ i ], povijestStup[ i ] );
		printf( "\n" );
		
		++total;
	}
	
	for( i = -n; i <= n; ++i )
	{
		if( i != 0 && 1 <= red+i && red+i <= n && 1 <= stup+i && stup+i <= n )  
			total += prebroji( red+i, stup+i, n, k-1, povijestRed, povijestStup, brojKorakaDosad+1 );
			
		if( i != 0 && 1 <= red-i && red-i <= n && 1 <= stup+i && stup+i <= n )  
			total += prebroji( red-i, stup+i, n, k-1, povijestRed, povijestStup, brojKorakaDosad+1 );
	}
	
	return total;
}


// ------------------------------------------------------------ main
int main( int brojParametara, char *parametar[] )
{
	int n, k, povijestRed[ 100 ], povijestStup[ 100 ], brN;

	if( brojParametara != 3 )
	{
		printf( "Upotreba: %s n k\n", parametar[ 0 ] );
		exit( 0 );
	}

	sscanf( parametar[ 1 ], "%d", &n );
	sscanf( parametar[ 2 ], "%d", &k );
	
	printf( "Grupa A:\n" ); brN = broji( n, n, n, k, povijestRed, povijestStup, 0 ); printf( "Broj nacina: %d\n\n", brN );
	printf( "Grupa B:\n" ); brN = koliko( n, n, n, k, povijestRed, povijestStup, 0 ); printf( "Broj nacina: %d\n\n", brN );
	printf( "Grupa C:\n" ); brN = nkn( 1, n, n, k, povijestRed, povijestStup, 0 ); printf( "Broj nacina: %d\n\n", brN );
	printf( "Grupa D:\n" ); brN = prebroji( 1, 1, n, k, povijestRed, povijestStup, 0 ); printf( "Broj nacina: %d\n\n", brN );
	
	return 0;
}
